\documentclass[12pt]{article}

%Packages
\usepackage{xurl}
\usepackage{graphicx}
\usepackage{gensymb}
\usepackage{fancyhdr}
\usepackage{enumitem}
%\usepackage{listings}
\usepackage{tikz}
\usepackage{import}
\usepackage{setspace}
\usepackage{tabu}
\usepackage{here}
\usepackage{xcolor}
\usepackage{longfbox}
\usepackage[a4paper, margin=1in]{geometry}
\usepackage{layouts}
\usepackage[hidelinks]{hyperref}
\usepackage{textcomp}
\usepackage{amssymb}
\usepackage{caption}
\usepackage[newfloat, cache=true]{minted}
\usepackage{dirtree}
\usepackage{pdfpages}
\usepackage[titletoc]{Appendix}

%Configuration

\definecolor{delim}{RGB}{20,105,176}
\definecolor{numb}{RGB}{106, 109, 32}
\definecolor{string}{rgb}{0.64,0.08,0.08}

\renewcommand{\contentsname}{Table of Contents}
%\renewcommand\listoflistingscaption{List of Code}

\captionsetup[listing]{position=top}

\mathchardef\mhyphen="2D
\onehalfspacing

\DeclareCaptionType{code}[Code Listing][List of Code] 

%\fancyhead{}
%\pagestyle{fancy}
%\fancyhead[R]{\textit{Matthew Cane}}
%\fancyhead[L]{\textit{Matrix Barcode And TOTP Based Secure Access System}}
%\fancyfoot[C]{\thepage}

\newfboxstyle{code}{border-style={none, none, solid, solid}, border-color=blue}
\hypersetup{linktoc=all}

\setlength{\parindent}{0pt}

\renewcommand{\baselinestretch}{1.5} % Line Spacing

\begin{document}

\title{\huge Matrix Barcode And TOTP Based Secure Access System}
\author{Matthew Cane\\18024137}
\maketitle
\thispagestyle{empty}
\pagestyle{empty}
\begin{center}
	\includegraphics[scale=0.5]{./Resources/title2.png}\\
	Programme Code: G401\\
	Module Code: UFCFR4-45-3
\end{center}

\newpage
\topskip0pt
\vspace*{\fill}
\begin{center}
\textbf{Acknowledgements}\\

I would like to thank my supervisor Dr Rong Yang for her guidance and unwavering faith in my abilities throughout my time at university, my parents for encouraging me to achieve my best, Emily Shepherd for inspiring me to fulfil my potential and providing invaluable advice, and finally to Zaffaria Foster, for supporting me while the world worked against us all.
\end{center}
\vspace*{\fill}

\newpage
\section*{Abstract}

This report covers the process of investigating if a matrix barcode and time based one-time password secure access system is a viable solution for building access. It also proposes how such a system could be designed and implemented as well as the process of testing. Different types of matrix barcodes were investigated, as well as other pieces of supporting technology and software to evaluate their performance and applicability to the system.\\

This report concludes that the overall concept is viable, that the algorithmic principles in its design are sound and, should the proper network security considerations be taken into account, it could be developed into practical product.

\newpage
\tableofcontents
\newpage
\listoffigures
\newpage
\listoftables
\newpage
\listoflistings
\newpage
\pagestyle{plain}
\setcounter{page}{1}

\section{Introduction}

Managing access to buildings and rooms can be a time-consuming process for site staff and property managers. Passwords and pin codes are weak and shared between many individuals and RFID cards can be cloned, lost or stolen. Time must also be spent to print and encode RFID enabled ID cards. This paper proposes an alternative to existing solutions; a security access system which makes use of time-based, one-time passwords (TOTP) shared using a matrix (2D) barcode generated by a mobile app. Current TOTP implementations are designed to be used as a second factor in multi-factor authentication and therefore the codes they output are intended to be human usable. This project explores the idea of using an algorithm to generate tokens that are not constrained by being able to be read and input by a human, but rather by an optical scanner such as a camera.\\

The broad aims of the finished system prototype are as follows: each user would have an app on their mobile device that would generate TOTP tokens which could then be scanned and used to access buildings and log into computer systems. The proposed system could also be used to authorise and log access to anything that would normally have a lock, for example lockers containing fleet vehicle keys, dangerous substances, or any other valuable asset.\\

All interactions with the system will be thoroughly logged and accessible to administrators in a web dashboard that will display a variety of metrics in a clear, readable format with optional email notifications for key events. Calculated metrics could include time in and out of the building, records of working hours, and footfall statistics. Events can also trigger alerts to select members of staff.\\

Research presented in this report outlines the different technologies that could be used to meet the goals of the system and help to reach conclusions on the advantages and disadvantages of different approaches. It also looks at how how best to utilise the different technologies and leverage their strengths.\\

\newpage
\section{Research}

In this section, the report will explore the technologies that need to be understood in order to implement the system proposed in this report.

\subsection{Message Authentication Code (MAC)}

A message authentication code, sometimes also called a message integrity code (Schneider, 2005), is a cryptographic technique used primarily to evaluate the integrity of a transmitted message. In it's most basic form, it uses a cryptographic hash function, usually MD5 or SHA-1 for their simplicity and speed, to create a near unique hash of the message, like a fingerprint. This hash is appended to the end of the message when it is sent. Once the message has been received, the recipient can then compute their own hash of the message, and compare it to the hash received with the message transmission. If the two hashes are identical, the  party can be sure that the message has not been corrupted or tampered with during transmission.

\begin{figure}[!h]
\caption{MAC Process Flow}
\centering
\includegraphics[scale=1]{./Resources/mac-flow.pdf}
\label{fig:MacFlow}
\end{figure}

The algorithm can also be described as $M\|H(M)$ where M is the message and H is a hashing algorithm. However, this is a naive way to authenticate a message as a way to protect against purposeful manipulation. A malicious actor is able modify the message, recompute the hash and forward it onto it's intended recipient and the manipulation is unable to be detected. Therefore, this method should only be used to check the integrity of a message or piece of data that may be corrupted.\\

A way to combat this very simple attack is to use a private key shared between the parties. This key is then appended to the message and used to generate the hash. This algorithm can be described as $M\|H(M\|K)$ where K is the shared secret key. However, according to Lawson (2009), this approach is susceptible to length extension attacks when the hashing algorithm used is based on a Merkle–Damgård construction. This includes MD5, SHA-1 and SHA-2. As long as the length of the original message is known, the message can be appended to, and the hash recomputed, without the secret key being known to the attacker by exploiting the internal state of the hashing algorithm. It should be noted that SHA-3 is not susceptible to length extension attacks.\\

In more practical uses of MACs, it is used to validate the integrity of a message, and the security of the message is left to public-key cryptographic techniques such as TLS or RSA which, when implemented correctly, protects a message from being read or modified by a 3rd party. Another way to prevent the exploitation of length extension attacks while still being able to use Merkle–Damgård based hashing algorithms is by using a HMAC.

\subsection{Hash-Based Message Authentication Code (HMAC)}

According to Krawczyk \textit{et al.} (1997), the HMAC algorithm can be described at the following:
\begin{center}
$hmac=H(K \oplus opad, H(K \oplus ipad, M))$\\
\end{center}

Where:

\begin{itemize}
\item H is the hashing algorithm in use.
\item B is the block length of algorithm H in bytes.
\item L is the length of the output of H in bytes.
\item K is a shared secret key of length L.
\item M is the message.
\item opad is \texttt{0x5c} repeated B times.
\item ipad is \texttt{0x36} repeated B times.\\
\end{itemize}

The XORs in the algorithm are used to derive two keys from one shared secret key using the ipad and opad values. These values were chosen due to their high Hamming distance (Bellare, Cantelli and Krawczyk, 1996). Therefore, another way to express this algorithm would be as follows, with all the previous variables as before except where $K_{1}=K \oplus opad$ and $K_{2}=K \oplus ipad$:

\begin{center}
$hmac=H(K_{1}, H(K_{2}, M))$
\end{center}


While HMAC is much less vulnerable to very simple attacks like MAC is, Bellare, Cantelli and Krawczyk (1996) say that an HMAC constructions security is closely related with the security of the underlying hash function. Any HMAC based on a weak hash function that has poor collision resistance, pseudo-randomness or any other weakness can allow the HMAC to be exploited in the same way.\\

This will be taken this into account when designing the algorithm for the system and an appropriately strong hash function  will be selected for use with the HMAC construction.

\subsection{HMAC Based One-Time Password (HOTP)}

The HOTP technique is used to derive a unique identifier from a secret shared key and an integer counter using a HMAC construction. Keys can be generated on a client and a server, and identity can be established if both keys are identical.\\

The HOTP algorithm, as described by M'Raihi \textit{et al.} (2005), is as follows:

\begin{center}
$hotp(K,C)=truncate(hmac \mhyphen sha \mhyphen 1(K,C))$\\
\end{center}
\newpage % NEWPAGE
Where:

\begin{itemize}
\item C is an 8-byte counter.
\item K is a shared, secret value.
\item T is a throttling parameter.
\item S is a resynchronization parameter.\\
\end{itemize}

The truncation method used is called dynamic truncation, which is described in the following section.

\subsubsection{Dynamic Truncation}
%quick explainer of what it is, how it works and why I won't be using it
Dynamic truncation is used to reduce the output size of the HMAC output to a human usable length, usually 6 digits.\\

The dynamic truncation algorithm according to M'Raihi \textit{et al.} (2005) is as follows. Where \texttt{string} the 20-byte result of HMAC-SHA-1(K, C):\\

\begin{listing}[h]
\caption{Dynamic Truncation Pseudocode}
\begin{longfbox}[code]
\begin{minted}[linenos]{text}
truncate(string):
	offset = least significant 4 bits in string[19] as int
	P = string[offset] to string[offset+3]
	return P excluding least significant bit
\end{minted}
\end{longfbox}\\
\end{listing}

The reasoning behind excluding the least significant bit of P is to eliminate any issues that may occur when performing modulo operations on CPUs with differing endianness.\\

However, the system proposed in this report will not be using dynamic truncation as the output from the TOTP algorithm that will be implemented will not be human readable. This allows for the use of much longer and more complex codes.


\subsection{Time-Based One-Time Passwords (TOTP)}

TOTP is an extention of HOTP, differing only where a timestamp is used in place of a counter. This reduces the complexity of the system, as clients and servers no longer need to maintain a counter. It does, however, add the requirement that both parties have access to the current UNIX time which in practical terms means being able to sync with an NTP server over the internet. If this is not possible, there are ways to get around this at the expense of security.\\

The TOTP algorithm can be described by M'Raihi \textit{et al.} (2011) as the following, where:\\

\begin{itemize}
\item X is the timestep length.
\item U is the current UNIX time.
\item K is the shared secret key.
\item T is the counter start time.
\end{itemize}

\begin{center}
$totp=hotp(K,(U-T)/X)$
\end{center}

TOTP finds significant use as a second factor in multi-factor authentication systems. Some popular examples are google Authenticator and LastPass Authenticator.

\subsection{Matrix Barcodes}

Matrix barcodes, also known as 2D barcodes, are a way to present machine-readable data in a way that can be easily printed and scanned with a camera, laser or other sensor.\\

This report will briefly cover a few of the most common matrix barcode standards, see Figure \ref{fig:matrixbarcodes}. These were chosen as they are the four matrix barcode standards that are supported by Google's ML Kit (Google, 2020) and are readable using popular Linux libraries (Willis, 2008), and are therefore fully supported on the operating systems used in the proposed system.

\begin{figure}[H]
\caption{Matrix Barcode Examples}
\centering
{\tabulinesep=1.5mm
\begin{tabu}{c c c}
\includegraphics[scale=1]{./Resources/QR_CODE_EXAMPLE.pdf} & \includegraphics[scale=1.1]{./Resources/AZTEC_CODE_EXAMPLE.pdf} & \includegraphics[scale=1.15]{./Resources/DM_CODE_EXAMPLE.pdf}\\ 
Quick Response & Aztec & Data Matrix \\
\multicolumn{3}{c}{\includegraphics[scale=1]{./Resources/PDF417_CODE_EXAMPLE.pdf}}\\ 
\multicolumn{3}{c}{PDF417}\\
\end{tabu}}
\label{fig:matrixbarcodes}
\end{figure}

\subsubsection{Quick Response (QR)}

QR is the most common type of matrix barcode. Invented in 1992 by Engineer Masahiko Hara for Denso Wave Corporation. It currently holds ISO/IEC standard 18004:2015 (International Organization for Standardization, 2015) however the standard is currently under review. The standard describes a number of ways to generate valid QR codes with 40 full-size versions and 4 micro versions, each with different levels of storage capacity and error correction. QR codes utilise Reed-Solomon error correction with four levels (See Figure \ref{tab:QRError}) which allows a trade-off between readability after damage and storage capacity.

\begin{table}[H]
\caption{QR Code Error Correction Levels}
\centering
\begin{tabular}{|c|c|}
\hline
\textbf{ECC Level} & \textbf{Damage Recovery Limit}\\
\hline\hline
L & 7\%\\
\hline
M & 15\%\\
\hline
Q & 25\%\\
\hline
H & 30\%\\
\hline
\end{tabular}
\label{tab:QRError}
\end{table}

The metadata of a QR code is made up a number of finder patters and locator markers, which define the location and orientation of the code, timing and format information. The number and size of these are different for each version. The size of a QR code is defined by the number of modules it is made up of. Eight modules combine to make a codeword, each of which can contain one byte of data in binary mode and also contains the error correction code.\\ 

\begin{figure}[H]
\caption{Version 1 QR Code Components}
\centering
\includegraphics[scale=1]{./Resources/QR_BREAKDOWN.pdf}
\label{fig:QRBreakdown}
\end{figure}

The smallest, version 1, is $21\times21$ modules and contains 26 codewords. See Figure \ref{fig:QRBreakdown} for a more detailed example of the layout of the code and dataword composition. Version 40, the largest, is made up of $177\times177$ modules and contains 3706 codewords. A version 40 QR code with ECC level L can store up to 2953 bytes of information\footnotemark, with losses attributed to error correction and increasing numbers of locator markers.

\footnotetext{Byte storage is being used to compare each of the matrix barcodes as this is how the system in this report will be using them, however other encoding modes may result in improved storage density.}

\subsubsection{Aztec}

The Aztec code was invented in 1995 and patented in 1997 by Hussey and Longacre (1997). The standard has entered the public domain and it currently holds ISO/IEC standard 24778:2008 (International Organization for Standardization, 2008).

\begin{figure}[H]
\caption{Two Layer, Full-Size Aztec Code Components}
\centering
\includegraphics[scale=1]{./Resources/Aztec_BREAKDOWN.pdf}
\label{fig:AztecBreakdown}
\end{figure}

A standard size Aztec code consists of one centred finder pattern with timing information running out from the centre (See Figure \ref{fig:AztecBreakdown}). The data and error correction information is encoded in modules, each of which represents one bit. Two module are stacked towards the centre of the pattern to make up a `domino' with the most significant bit closest to the outside edge. Dominoes are combined to make codewords, but the length of the codeword depends on the size of the pattern (See Figure \ref{tab:AztecCodewordLengths}).

\begin{table}[H]
\caption{Aztec Codeword Lengths}
\centering
\begin{tabular}{|c|c|}
\hline
\textbf{Number of Layers} & \textbf{Bit Encoding Length}\\
\hline\hline
1 and 2 layers & 6-bit encoding\\
\hline
3 to 8 layers & 8-bit encoding\\
\hline
9 to 22 layers & 10-bit encoding\\
\hline
23 to 32 layers & 12-bit encoding\\
\hline
\end{tabular}
\label{tab:AztecCodewordLengths}
\end{table}

An Aztec code can be $15\times15$ modules in size, storing 6 bytes of data, up to $151\times151$ modules in size storing 1914 bytes. The Aztec standard also allows for error correction levels from 5\% to 95\% with a recommended ECC level of 23\%.

\subsubsection{Data Matrix}

Data Matrix was patented in 1991 by Cymbalski and Priddy (1991), however it is now in the public domain and holds ISO/IEC standard 16022:2006 (International Organization for Standardization, 2006). There are two sets of versions of the Data Matrix, ECC000-140 (comprised of versions 000, 050, 080, 100 and 140) and ECC200, which is the most recent version. ECC000-140 are obsolete and should no longer be used.\\

ECC200 consists of a finder pattern border that surrounds the outside of the code with data and error correction stored in 8-bit codewords tiled across the inside of the code (See Figure \ref{fig:DataMatrixBreakdown}). Once the data area can no longer accommodate whole datawords, they are split into chunks and placed in the remaining spaces in a pattern defined in the standard. This pattern changes depending on the size of the code.\\

\begin{figure}[H]
\caption{Size 12 ECC200 Data Matrix Code Components}
\centering
\includegraphics[scale=1]{./Resources/DATA_MATRIX_BREAKDOWN.pdf}
\label{fig:DataMatrixBreakdown}
\end{figure}

A Data Matrix's size can be between $10\times10$ and $144\times144$ with the largest size able to store up to 1556 bytes. %NEEDS MORE

\subsubsection{PDF417}

The PDF417 standard was devised in 1991 by Wang (Pavlidis, Swartz and Wang, 1992) and holds ISO/IEC standard 15438:2015 (International Organization for Standardization, 2015). A PDF417 code can store information encoded in a mix of bytes, numeric and text data using a base 929 encoding scheme.\\

Each code consists of a start and stop pattern at either end, a left and right row indicator that provides metadata about the code, and a number of datawords that contain the information (see Figure \ref{fig:PDF417Example}). A PDF417 code can contain up to 30 datawords, which in byte encoding mode can store a maximum of 1100 bytes according to the specification. This standard utilises Reed-Solomon error correction.\\

\begin{figure}[H]
\caption{PDF417 Example With Three Codewords}
\centering
\includegraphics[scale=0.75]{./Resources/PDF417_BREAKDOWN_2.pdf}
\label{fig:PDF417Example}
\end{figure}

This code is not as common as the other matrix barcodes discussed in this report, however it finds use on postage labels, boarding passes (See Figure \ref{fig:BoardingPass}) and ID cards. Due to it's form factor, which according to Accusoft Corporation (2007) is up to 4 times the area of a QR or data matrix code, it has been determined that it will not be suitable for the application described in this report.\\

\begin{figure}[h]
\caption{Boarding Pass With PDQ417 Barcode}
\centering
\includegraphics[scale=0.12]{./Resources/Boardingpass.jpg}
\label{fig:BoardingPass}
\end{figure}

\subsubsection{Images Within Matrix Barcodes}

As can be seen in figure \ref{fig:QRWithLogo}, it is possible to embed a logo or other image within a matrix barcode. This is especially popular for QR codes as a centred image does not block any of the finder patters. However, this technique is not defined within the standards of any of the matrix barcodes explored by this paper.\\

\begin{figure}[H]
\caption{QR Code With Inset Logo}
\centering
\includegraphics[scale=0.15]{./Resources/QR_WITH_LOGO.pdf}
\label{fig:QRWithLogo}
\end{figure}

This works by exploiting high levels of error correction found within the standards. As can be seen in figure \ref{tab:QRError}, a QR code can be encoded with up to 30\% error correction, meaning up to 30\% of the code can be obscured or damaged and is still able to be read correctly. There are standards such as FrameQR\textsuperscript{\textregistered} (Denso Wave) that cuts out an area so that an image may be added, however these techniques are not in the ISO QR standard and cannot be relied upon to be read correctly by all implementations of the decoder algorithm. 

\subsubsection{Best Suited Matrix Barcode}

Of the four matrix barcodes evaluated so far, QR, Aztec and Data Matrix could each be used successfully with the system as their form factor and data density are comparable. However QR, as the most popular matrix barcode, enjoys the most comprehensive support in popular software libraries. This makes it the best candidate for this project as it allows for fast and easy development of the aspects of the project that make use of it.

\subsection{Software Libraries}

A number of software libraries were used in this project, as writing much of the core functionality would be excessively time consuming.

\subsubsection{PiCamera}

PiCamera is the library written by Dave Jones (2016) to enable interaction with the various Raspberry Pi camera modules. It is written in pure Python, and provides an API for the various capture modes of the camera module as well as basic image manipulation. The library makes available three ports on the camera, the \emph{still port} that is used for images, the \emph{video port} that is used for video and the \emph{preview port} which is very similar to the video port.\\

\begin{table}[h]
\caption{Pi Camera v1 Module Sensor Modes}
\centering
\begin{tabular}{|c|c|c|c|c|c|c|c|}
\hline
\textbf{Mode} & \textbf{Resolution} & \textbf{Aspect Ratio} & \textbf{Framerates} & \textbf{Video} & \textbf{Still} & \textbf{FoV} & \textbf{Binning}\\
\hline \hline
1 & 1920$\times$1080 & 16:9 & 1 to 30 & \checkmark & & Partial & None\\
\hline
2 & 2592$\times$1944 & 4:3 & 1 to 15 & \checkmark & \checkmark & Full & None\\
\hline
3 & 2592$\times$1944 & 4:3 & 1/6 to 1 & \checkmark & \checkmark & Full & None\\
\hline
4 & 1296$\times$972 & 4:3 & 1 to 42 & \checkmark & & Full & 2$\times$2\\
\hline
5 & 1296$\times$730 & 16:9 & 1 to 49 & \checkmark & & Full & 2$\times$2\\
\hline
6 & 640$\times$480 & 4:3 & 42 to 60 & \checkmark & & Full & 4$\times$4\\
\hline
7 & 640$\times$480 & 4:3 & 60 to 90 & \checkmark & & Full & 4$\times$4\\
\hline
\end{tabular}
\label{tab:PiCamModes}
\end{table}

The library allows for images to be captured using the video or still port, however if a resolution below 2592$\times$1944 is requested through the still port, the camera will take an image at 2592$\times$1944 and convert it to the size requested. If an image is requested through the video port at a resolution other than a resolution that matches one of the sensor modes, the requested resolution is rounded up to the nearest matching mode resolution and scaled back to the requested resolution. Images taken with the still port will also be slower to process than those taken with the video port as a more intensive de-noise algorithm is used to achieve sharper images.\\

\subsubsection{Pillow}

Pillow (Lundh and Clark, 2020) is a fork of PIL (Python Imaging Library) and adds a range of image processing capabilities to Python such as loading, displaying, manipulating and saving images. This project utilises a very small set of it's features, namely it's ability to import image data from a file or buffer in a range of formats and convert it to a Image object which can be accessed by the PyZBar library.\\

It's ability to write out images is also used in a debugging role so developers are able to review the images that are being captured.\\

\subsubsection{PyZBar}
\label{PyZBar}
PyZBar (Hudson, 2020) is the Python 3 wrapper for ZBar, a popular open source library written in C which is used mainly for reading traditional linear barcodes but also has the ability to read QR codes. This library was chosen for it's speed, reliability and simplicity. It is able to decode Pillow Image objects which makes it especially suited for use with this project.\\

\subsection{Docker and Containerisation}

Docker is a containerisation technology built primarily using the following Linux features: namespaces, control groups and chroot. Containerisation allows for software systems to run in an isolated manner on the same operating system, similar to a virtual machine, but sharing the same kernel. This eliminates the resource overheads associated with running virtual machines, while retaining with many of the security and management advantages. As can be seen in figure \ref{ref:ContainerVsVM}, a system with three applications which must remain isolated, running in a VM environment, requires four operating system kernels. However, a container based system requires only one operating system and a container engine that is much less resource intensive than a hyper-visor.\\

\begin{figure}[H]
\caption{Containerisation vs Virtual Machines}
\centering
\includegraphics[scale=1]{./Resources/container-vs-vm.pdf}
\label{ref:ContainerVsVM}
\end{figure}

Deployment is also made faster and easier by utilising containers. Running a single docker-compose script can, when properly configured, result in a system being up and available within a much shorter space of time, compared to provisioning and configuring a virtual machine. Containerisation also lends itself to load-balancing and reliability, as orchestration technology such as Kubernetes and Amazon's Elastic Container Service can dynamically scale and self-heal containers across multiple servers. There are many cloud services that enable easy, managed container environments, such as Google Cloud's GKE and Microsoft's AKS. While Docker is the most commonly used containerization technology, other container engines exist such as LXD and Rkt.\\

\newpage % NEW PAGE
\subsection{Dashboard Frameworks}
\label{dashboards}

The system will require a dashboard for administrators to view data produced by the system and it's users. There are many web dashboard frameworks available and this report will now analyse a few of the most popular freely available, open source solutions according to Slant Product Rankings (Slant, 2021) to evaluate which is most suable solution for the project. They will be evaluated in terms of:

\begin{itemize}
\item Usability.
\item Ease of development.
\item Flexibility.
\item Aesthetics.
\end{itemize}

\subsubsection{Tipboard}

Tipboard (Alegro Tech, 2017) is dashboard framework written in JasaVascipt and Python. It incorporates it's own Python based web server using the Tornado framework but can also be used with a reverse proxy such as Apache or Nginx.\\

Tipboard uses \emph{.yml} files to set the layout and \emph{.css} and \emph{.js} files to modify the styling of the dashboard tiles. Data is inserted into the tiles through a REST API. This is advantageous as once the tiles have been configured any back-end language can be used, giving more choice to developers. Documentation of the framework is excellent with lots of examples which should make development fast and efficient. As Tipboard is developed for Linux based systems, integrating it into Docker should be a straightforward process.\\

This framework seems aimed at smaller projects and is well encapsulated with little work needed to incorporate it into existing projects. From this, Tipboard appears to be a good candidate for the project.\\

\subsubsection{Grafana}

Developed by Grafana Labs (2021), Grafana is a dashboard framework aimed at enterprise users. Unlike Tipboard, Grafana has the ability to connect to many different data sources directly, such as databases, query engines, monitoring systems and cloud engines. It also incorporates a plug-in system that allows users to add pre-made dashboard and panels.\\

Grafana seems focused on enterprise customers wishing to integrate a dashboard into their existing software systems and recommend it's use with their own cloud solution. While powerful, Grafana seems to be too heavy-weight for the project at it's current stage, however the high levels of extendibility could benefit the project on a long-term basis.\\

\subsection{Database Solutions}

Databases are a essential part of any data-driven application, however there are a wide range of infrastructure layouts, models and database management systems that may be suitable for this software system. The following section will cover some of the broad differences between different types of databases that will help rationalise the choice of database made for this system.\\

\subsubsection{Relational Vs Non-Relational Database models}

%What are relational databases, why are they good, weaknesses
Relational databases, often called SQL databases, are so called because they use Standard Query Language to perform queries and form highly structured, rigid data storage rules. Relational databases store their data in tables that consist of rows and columns. The relational model is very mature, having been first developed in in 1970 by Codd (1970) and as a result has accumulated a lot of legacy feature support, which may be advantageous when dealing with a dataset with a lot of variety.\\


%What are non-relational databases, why are they good, weaknesses
Non-relational databases, often called NoSQL databases, are a broad category covering many different database models. They are characterised by not following the traditional table-column-row format. Common non-relational data models are document, key-value, graph and triplestores. These alternate models can can be much more effective than the relational model in the specific use-cases for which they were designed, but may not be appropriate for the majority of uses. It should also be noted that many DBMS have support for multiple database models, for example Oracle Database, while primarily a relational database, can also use document store, graph and triplestore store models.\\

%Comparison between the two


\subsubsection{Client-Server Vs Embedded Databases}

%Something about client-server databases here. Advantages, disadvantages
Client-server databases are what are traditionally thought of when talking about databases. A DBMS is run as an always-on service which is accessed by clients over a network, either locally or via the internet.\\

\begin{figure}[h]
\caption{Client-Server Vs Embedded Database Architecture}
\centering
\includegraphics[scale=1]{./Resources/db-server-serverless.pdf}
\label{fig:server-serverless}
\end{figure}

Embedded databases, also known as server-less databases (which is not to be confused with the serverless cloud computing paradigm) are integrated within the software that is utilising the database. Their database engine is often used more similarly to a software library where they are called upon and spun-up when needed, rather than running constantly as a daemon or service as with a traditional DBMS. Embedded databases are commonly used in embedded hardware, operating systems, industrial equipment and even aircraft software (SQLite).\\

Embedded databases are often more performant than client-server databases as they eliminate the need for network calls and other overheads which adds latency to the query; however, they lack the advanced features of a fully fledged DBMS such as high concurrency, user management, sharding/load balancing, scripting and very large datasets. Many embedded databases also lack the wide range of available datatypes available to traditional databases, often operating with a stripped down set of datatypes for simplicity. This can also be seen as an advantage as less complexity means almost zero maintenance and less expertise is required to use them. The most commonly used embedded database is SQLite, according to DB-Engines (2021).\\

The choice between client-server and embedded is highly dependent on the use-case. In places where the client-server paradigm is required, or where the usage needs of the system outstrip the feature-set of the lightweight DB engines used in embedded databases, a traditional client-server system is beneficial. However if the data is only going to be accessed directly by one piece of software and access over the network is not necessary then an embedded database may be preferable.\\

\newpage
\section{Requirements}

The process of requirements analysis involves identifying the stakeholders of the system and their functional and non-functional requirements. ISO standard 21500:2021 (2021) defines a stakeholder as: 

\begin{center}
\textit{``(A) person, group or organization that has interests in, or can affect, be affected by, or perceive itself to be affected by, any aspect of the project, programme or portfolio''.} 
\end{center}

It is important to accurately identify the stakeholders, their needs, and how the system could affect them, in order to design the system in a way which servers them best, as the success of the system being proposed in this report is highly dependent on user experience. Using this definition, section \ref{sec:stakeholders} identifies and describes each group of stakeholders.\\

In order to design any system, a number of requirements must be identified. These can be broken down into two categories, functional and non-functional requirements. A functional requirement describes a clear component or module of the system that can developed and provide additional functionality to the system. A non-functional requirement is an attribute that can be used to define a functional requirement or describe the system as a whole.\\

\subsection{Stakeholders}
\label{sec:stakeholders}

\begin{itemize}
\item \textbf{End user.} This is any individual who could be described as having used the system to access an area secured by the system, or any individual who is granted an identity by the system.
\item \textbf{Site Owner.} The individual, individuals or organisation who could be said to own the facility in which the system is deployed. They have an interest in the security of their facilities, and thus would be affected if the system does not fulfil it's purpose.
\item \textbf{Facilities Manager.} The person or persons who are charged by the site owner to ensure the security of the facility in which the system is deployed. They could also be the same person or persons as the site owner.
\item \textbf{Facilities Staff.} These are the individuals whose responsibilities are to administer the system on a day-to-day basis.
\end{itemize}

The considerations of each group of stakeholders must be taken into account during the design and implementation of the system.

\subsection{Functional Requirements}

The functional requirements for the system have been analysed using the MoSCoW system, which was first developed by Clegg (1994), and is a method used to prioritise requirements during project development and is often used within agile development frameworks. The system calls for functional and non-functional requirements to be organized into four categories:

\begin{itemize}
\item \textbf{MUST} have this feature. The set requirements that must be completed to form a minimum viable product. Without these requirements being fulfilled, the system is non-functional. 
\item \textbf{SHOULD} have this feature. These requirements are not essential, but contribute significantly to the usability of the system. During development, resources should be allocated to these requirements once the MUST features are implemented.
\item \textbf{COULD} have this feature. If resources are available, these features, that provide functionality to the product above the more essential requirements, could be worked on, but are not as important to the project as SHOULD or MUST requirements.
\item \textbf{WON'T} have this feature (in this product iteration). These requirements are beyond the scope of this development cycle, and could be considered for future product iterations.
\end{itemize}

The following sections define the requirements for the project based on the MoSCoW system:

\subsubsection{MUST Requirements}

\begin{itemize}
\item The system must prevent unauthorised access to facility through doors, within the bounds of reasonable expectation, i.e excluding forced entry by physical means. This is the primary requirement for the system.
\item The system must be able to allow access to authorised users or groups of users. Users must be explicitly granted authorisation.
\item The system must allow administrators the ability to add and remove authorisation to individual users and groups of users.
\item The user interface must be designed in an accessible way.
\end{itemize}

\subsubsection{SHOULD Requirements}

\begin{itemize}
\item Administrators should be able to view system data in an easily digestible way.
\item The system should facilitate the logging of all aspects of the system to a central database.
\item Users should have an easy onboarding process.
\end{itemize}

\subsubsection{COULD Requirements}

\begin{itemize}
\item The system could be able to be used on a variety of operating systems and devices.
\item The administrator dashboard could have login/authentication in place.
\end{itemize}

\subsubsection{WON'T Requirements}

\begin{itemize}
\item Won't have different levels of administrator rights e.g. access to different parts of the dashboard.
\item Will not utilise TLS or any other encryption for network communications.
\end{itemize}

\subsection{Non-Functional Requirements}

\begin{itemize}
\item The system must be able to be configured on deployment to meet the requirements of a number of potential use-cases. Administrators should have the option for doors fail-safe or fail-secure.
\item The system must not put the privacy of it's users at risk. The logged activity must only be available to authenticated users.
\item They system must be able to authenticate a user and unlock a door within a reasonable amount of time, as not to delay the users ingress.
\item The system must be cost effective, not only to deploy but also to maintain and administer. Compute, network and storage usage should be kept to a minimum without hindering functionality.
\end{itemize}

\newpage
\section{Design}

The system is made up of three distinct sections: 

\begin{itemize}
\item An app running on an Android based smart phone. This would be used by the end-users of the system to acquire an identity and gain access to doors.
\item A door scanner running Linux on a Raspberry Pi Zero W. This would scan the codes presented by the users and query their credentials using the API.
\item A back-end with a database and administrator dashboard running in a containerised Linux based environment.
\end{itemize}

\subsection{System Overview}

Figure \ref{fig:SystemFlow} shows an overview of the system in regards to data flow, main functionality and decision-making. The trigger for the primary system flow is a user opening the app on their Android device. This will initiate the generation of a 256-bit token which is generated by performing a SHA-3-HMAC with a secret unique to the user and a time step based off the current Unix time. This token is appended to the users unique ID to create a string that is encoded into a QR code. This QR code is then displayed on the screen which the user presents to the door scanners camera.\\

The door scanner reads the barcode with it's camera, appends a door ID to the message and forwards it to the back-end systems API. The API logic extracts the user ID, token and door ID. It then looks up the users secret from the user ID in the message, and performs the same steps taken by the client to generate the secret. The system then compares the newly generated token with the token provided by the user and if a match is found a message is sent to the door scanner to unlock the door. If not match is found, the door will remain locked.\\

The system then logs the resulting transaction in the database for administrators to read via a web dashboard. Administrators are able to track key metrics through the web dashboard.\\

Each of these aspects of the system and their design are covered in more detail in the following sections.\\

\begin{figure}[H]
\caption{Overall System Flow}
\centering
\includegraphics[scale=1]{./Resources/system-flow.pdf}
\label{fig:SystemFlow}
\end{figure}

\subsection{Android Application}

The Android application will serve two purposes, the first will be reading a QR code that contains the components required to perform the TOTP calculation, the other generating the TOTP and displaying it as a QR code for the door scanner to read.

\subsubsection{User Interface}

The UI of the app will be very simple to ensure the user experience as streamlined as possible. The app servers a utilitarian purpose, so excess animation and loading times would hinder the user experience. Therefore animations will be kept to a minimum. Figures \ref{fig:Wireframe} and \ref{fig:Wireframe2} show the wireframe design for the UI.\\

The app will have two activities: 

\begin{itemize}
\item The main activity showing the QR code, users current identity a.k.a their name in the back-end database as well as a button that allows the user to enter the change identity activity.
\item A secondary activity that allows users to scan a QR code containing an identity and secret.
\end{itemize}

\begin{figure}[H]
\caption{Main Activity Wireframe Design}
\centering
\includegraphics[scale=0.5]{./Resources/app-wireframe.pdf}
\label{fig:Wireframe}
\end{figure}

\begin{figure}[H]
\caption{New Identity Wireframe Design}
\centering
\includegraphics[scale=0.5]{./Resources/app-wireframe-2.pdf}
\label{fig:Wireframe2}
\end{figure}

\subsubsection{Security Considerations}
% Why use biometric security? How will the secrets be stored securely?

The app will need to be designed with security as a primary consideration, as this is the only part of the system which is accessible to a broad number of users. It is important that the app should only be operable by the owner of the device, so the app will take advantage of Androids biometric authentication. The authentication levels within Android are defined as class 1 to class 3 with, in general, class 1 being password, pin or pattern unlock, class 2 being fingerprint or face authentication with more stringent software security protocols, and class 3 being similar to class 2 with even more stringent software security requirements. Class 3 security is defined in the Android 11 compatibility specification section 7.3.10 as:

\begin{itemize}
\item MUST meet all the requirements of Class 2.
\item MUST have a hardware-backed keystore implementation.
\item MUST have a spoof and imposter acceptance rate not higher than 7\% as measured by the Android Biometrics Test Protocols.
\item MUST challenge the user for the recommended primary authentication (e.g. PIN, pattern, password) once every 72 hours or less.
\end{itemize}

Before displaying the QR code token, the app will ensure the users identity by requesting biometric authentication. This will prevent unauthorised access of the app, reducing the chance of unauthorised opening of the door.\\

There are two ways to securely store credentials in Android, using the \emph{KeyChain}, which is used for system-wide credentials that can be accessed by several apps with user consent, and the keystore which lets apps store their own private credentials securely. Secrets stored in the keystore can also be stored in a hardware security module, known as a \emph{StrongBox}, as long as the hardware supports it. This is a module separate from the main hardware with it's own CPU, storage and true random-number generator and can support many encryption algorithms such as RSA 2048 and AES 256. The app will therefore use the hardware-backed \emph{StrongBox} keystore to store user secrets, where possible, for maximum security.\\

\subsubsection{Transferring User Secrets}

The app must be able to retrieve and store the users ID and secret in order to generate the tokens. It will do this by reading QR codes using the camera on the device which are to be generated by the back-end. The codes will contain the users ID, user secret and user name. These QR codes are only dispensed from a secure terminal with administrators in attendance to confirm the identity of the user. This ensures that the users device is loaded with the correct secret.\\

\newpage %NEW PAGE
\subsection{Door Scanner}

The door scanner acts as an intermediary between the visual output of the smart phone and the processing of the back-end. It's goal is to read the information from the barcode, decode it, validate that the data is in the correct format and pass it to the back-end system for processing. It is also listening for a message from the back-end to unlock the door. In a deployed system there may be many of these devices inset in doors or adjacent walls, each of which require power and network connectivity. Therefore the hardware used for this part of the system must have:\\

\begin{itemize}
\item A high resolution camera able to read barcodes displayed on low DPI displays.
\item The processing power required to decode barcodes from images.
\item Low power draw.
\item The ability to control locking mechanisms.
\item Wired or wireless connectivity to allow for flexible deployment.\\
\end{itemize}

The hardware chosen for the system that meets all these requirements is the Raspberry Pi Zero W with the ZeroCam inside an official Raspberry Pi Zero case, which can be seen in figure \ref{fig:piCase}.

\begin{figure}[H]
\centering
\caption{Raspberry Pi Zero W Case With Camera (Barnes, 2017)}
\begin{tabular}{c c}
\includegraphics[trim=100 0 100 0,clip,scale=0.425]{./Resources/Pi-Zero-W-Camera-Case.jpg} & \includegraphics[trim=75 0 75 0,clip,scale=0.6]{./Resources/Pi-Zero-W-official-case.jpg}
\end{tabular}
\label{fig:piCase}
\end{figure}

\newpage % NEW PAGE

The Raspberry Pi Zero W has the following hardware specifications:
\begin{table}[H]
\caption{Raspberry Pi Zero W Specifications}
\centering
\begin{tabular}{|c|c|}
\hline
\textbf{Component} & \textbf{Details}\\
\hline \hline
CPU & 32-bit ARM Based Broadcom BMC2835 at 1GHz\\
\hline
RAM & 512MB\\
\hline
Power Consumption & Max 230mA at 5V over Micro USB or GPIO\\
\hline
Storage & Micro SD Card\\
\hline
WLAN & 802.11b/g/n\\
\hline
Bluetooth & Version 4.1 and BLE\\
\hline
Video Output & Mini HDMI\\
\hline
Wired Connectivity & 40-pin GPIO, SCI Camera Connector, USB OTG\\
\hline
\end{tabular}
\label{tab:PiSpecs}
\end{table}

The ZeroCam camera module is designed specifically for use with the Raspberry Pi Zero and Zero W and is connected to the board with a flexible ribbon cable. Table \ref{tab:PiCamSpecs} details the specification of the camera module.

\begin{table}[H]
\caption{ZeroCam Specifications (OmniVision, 2009)}
\centering
\begin{tabular}{|c|c|}
\hline
\textbf{Component} & \textbf{Details}\\
\hline \hline
Sensor & OmniVision OV5647\\
\hline
Picture Resolution & 2592$\times$1944 pixels (5MP) at 15 FPS\\
\hline
Video Resolution & 1080p At 30 FPS\\
\hline
Focus Levels & 1m to infinity\\
\hline
Lens & f2.9\\
\hline
Focal Length & 3.6mm\\
\hline
Field Of View & 53.5\degree$\times$41.41\degree\\
\hline
CCD Pixel Size & 1.4$\mu$m\\
\hline
\end{tabular}
\label{tab:PiCamSpecs}
\end{table}


The door scanner will also be fitted with an audio-visual alert system in the form of green, yellow and red LED lights and a buzzer. This improves the accessibility of the system to those visually or audibly impaired. The yellow LED will display system status, with a solid light indicating normal operation and a flashing light accompanied by matching buzzing sound indicating a system error. The red LED will show with an accompanying buzz when a code scan has not resulted in a door unlock and a green LED and accompanying buzz is shown when the door is successfully unlocked.\\


This single board computer was chosen over the many alternatives available for the following reasons:

\begin{itemize}
\item Cost
\item Flexibility
\item Form Factor
\item Software Compatibility
\end{itemize}

\subsubsection{Cost}

A Raspberry Pi Zero W, ZeroCam, case and appropriate connectors can be purchased for approximately \pounds 35 with discounts available for bulk purchases. This makes this solution very inexpensive to develop for, and to deploy at scale.

\subsubsection{Flexibility}

As the Raspberry Pi Zero W uses a 32-bit ARM CPU with 512MB of RAM, it is able to run full Linux kernels compiled for the ARM architecture, including a desktop environment that can be used during development, however, this would be disabled in production to reduce system overheads. It has a plethora of connectors available enabling the device to work with a large number of door locking mechanisms with minimal electrical engineering.\\

Additionally it consumes very little power, 230mA at 5V, during intense workloads such as outputting video, recording at 1080p and using WiFi simultaneously. A 1A power supply is recommended by the documentation from the Raspberry Pi Foundation. This could allow for the door scanner to run on battery power for up to 9 hours on a single 18650 battery cell which could be useful for ad hoc temporary deployments.

\newpage % NEW PAGE
\subsubsection{Form Factor}

The Raspberry Pi Zero W is very small and lightweight which makes it ideal for a wall or door mounted device, see figure \ref{fig:PiLayout}. The case and camera increase the dimensions to 79mm $\times$ 37.7mm $\times$ 16.1mm, around the size of a large doorbell. 

\begin{figure}[h]
\caption{Raspberry Pi Zero W Board Layout}
\centering
\includegraphics[scale=1]{./Resources/pi-layout.pdf}
\label{fig:PiLayout}
\end{figure}

\subsubsection{Software Compatibility}

The Raspberry Pi Zero W is very well supported by the Raspberry Pi Foundation and it's partners. Libraries that allow for easy interaction with the Zero W hardware are available for a number of popular programming languages such as C, C++, Java, Python and Perl and it can utilise any open source software that can be compiled for ARM.

\subsubsection{Library Performance on the Raspberry Pi Zero W}

In the process of testing the performance of the system, a series of measurements were taken using the libraries listed above on the Raspberry Pi Zero W with the ZeroCam in order to establish the best setting for performance.\\

\newpage % ================================================================================

The PiCamera module was tested using each of the sensor modes shown in table \ref{tab:PiCamModes} and in output formats compatible with Pillow using the video and still ports. In mode 3, 2592$\times$1944, the capture times for various file formats can be seen in table \ref{tab:PiCamFormatSpeeds} with the data being presented as an average over five runs with the data stored into a stream buffer. The results show that JPEG cature through the video port is by far the fastest to return an image, and thus will be used as the default file format and port going forwards.\\

\begin{table}[H]
\caption{PiCamera Format Capture Speeds in mode 3.}
\centering
\begin{tabular}{|c|c|c|}
\hline
\textbf{Format} & \textbf{Still Port} & \textbf{Video Port}\\
\hline \hline
JPEG & 588ms & 293ms\\
\hline
PNG & 6005ms & 10592ms\\
\hline
GIF & 2759ms & 7195ms\\
\hline
\end{tabular}
\label{tab:PiCamFormatSpeeds}
\end{table}

The PyZBar Library was benchmarked using images that were captured in JPEG format through the video port and imported with Pillow as a PIL Image object. As can be seen in table \ref{tab:PiCamModeSpeeds} the decode time drops as the resolution decreases, with the exception of mode 2 and 3, which, while decoding the same image resolution, have slightly differing times. It has not been determined what the reason for this is.

\begin{table}[H]
\caption{PyZBar Decode Speeds}
\centering
\begin{tabular}{|c|c|c|}
\hline
\textbf{Mode} & \textbf{Resolution} & \textbf{Decode Speed}\\
\hline \hline
1 & 1920$\times$1080 & 2076ms\\
\hline
2 & 2592$\times$1944 & 4964ms\\
\hline
3 & 2592$\times$1944 & 3457ms\\
\hline
4 & 1296$\times$972 & 786ms\\
\hline
5 & 1296$\times$730 & 720ms\\
\hline
6 & 640$\times$480 & 233ms\\
\hline
7 & 640$\times$480 & 178ms\\
\hline
\end{tabular}
\label{tab:PiCamModeSpeeds}
\end{table}

Pillow was consistent in its speeds to decode JPEG images regardless of resolution, averaging around 25ms.\\

From these results, it has been established that the optimum configuration for reading QR codes with the Raspberry Pi Zero W is taking images through the video port in JPEG format in mode 4. This mode was chosen as it allows for resonable decode speeds at a square aspect ratio which is more suitable for this application. This gives a total image capture and decode time of around 1000ms $\pm$ 100ms, during which the CPU usage is between 85\% and 95\%, showing that the CPU is being fully utilised. While running in this configuration, the CPU reaches a peak temperature of 60\degree C, which is well within the safe rated working range of 0\degree C to 85\degree C.

\subsection{Back-End}

The back-end of the system is comprised of three systems, an API which will handle the interaction with the database and core system logic, a web interface for administrators and the database. Each of these will be in their own separate Docker containers to enhance deployment flexibility, reliability and security.\\

If deployed to a production environment, the back-end of the system will have to be modified to accommodate the use of TLS encryption to ensure data security, however, in the interest of time, this prototype will not.\\

\subsubsection{API}

The API will be written in Python primarily using the Flask and Flask-RESTful frameworks. Flask is a simple, lightweight WSGI framework which can be extended using Flask-RESTful to facilitate the implementation of a fully-featured REST API.\\

Python was chosen as the back-end language as it is also being used for the door scanner software. Reducing the number of different languages used in a project is a key goal that should simplify development and maintenance.\\

\subsubsection{Web Interface}

The web interface will incorporate two features, a dashboard to monitor the system and display key statistics and an area to add, view and modify the data in the database. After careful consideration of the dashboard options as presented in section \ref{dashboards} on page \pageref{dashboards}, is was decided that a custom made dashboard would be a better fit for the prototype being demonstrated. This is because integrating pre-existing dashboards would not fit well with the integrated design approach that the web interface is trying to achieve. Therefore, the web interface will be structured and styled using HTML5 and CSS using the W3.css framework. This has been chosen for it's simplicity, ease of development and it's prior use by the development team. It allows for responsive, well styles web pages to be built quickly with none of the complexity of implementing a more fully-featured framework such as Vue.js or Bootstrap. The scripting for each web page will be written in vanilla JavaScript as much as possible, again to minimise technical complexity and reduce the development time.\\

The dashboard will display a number of key statistics showing information derived from the database. These include:

\begin{itemize}
\item The number of users, zones, groups and doors currently registered in the database.
\item The total number of users who have used the system within a set time period.
\item The total number of rejected entries with a set time period.
\item The number of unique users within a set time period.
\end{itemize}

The web page used to add and modify data in the system will be constructed using Flask and the W3.css framework. These were chosen due to their simplicity and ease of use. It will include the ability to:

\begin{itemize}
\item Add, remove, modify and view all users, groups, zones and doors.
\item Add and remove users from groups.
\item Add and remove user and group permissions. 
\item View all logged events.
\end{itemize}

Below, on page \pageref{fig:DashWireframe}, is a wireframe representation of the basic page layout. The dashboard section will be split into separate panels that can be used to display information in a number of ways. This could be a simple integer, or string display, or, if more information is required, a bar, pi or line graph. The layout is flexible, as more or less panels can be displayed as needed. This also goes for the data modification section, where each button would show a modal with the relevant form or table. Rows of buttons can be added or removed as necessary.\\

\begin{figure}[H]
\caption{Web Dashboard Wireframe}
\centering
\includegraphics[scale=0.6]{./Resources/Dashboard-Wireframe.pdf}
\label{fig:DashWireframe}
\end{figure}

\subsubsection{Database}

The systems modular back-end design using Docker Compose makes it easy to swap in and out different database systems, however, the system has been designed around the relational database model and will use SQL for it's database calls. For the demonstration build, it will use the SQLite embedded database, however it has been tested to work with MariaDB with minimal modification to the \emph{docker-compose.yml} and \emph{DBInitScript.sql} files and \emph{db.connInit()} function.\\ 

SQLite was chosen for it's simplicity, ease of use and lightweight operation and, as the only piece of software directly communicating with the database is the API, it can easily be integrated into the API system. The advanced features that a DBMS brings were not found to be necessary and not having a separate database container was found to dramatically reduce the required system resources required to run the back-end. In addition, SQLite 3 is included in all versions of Python 3, meaning no additional dependences need to be installed. In a production deployment, the database should be encrypted using the SQLite Encryption Extension to improve data security, however, for the demonstration it is not used, in order to simplify and speed up development.\\

Figure \ref{fig:DB-LRD} on page \pageref{fig:DB-LRD} shows the logical relationships between columns with foreign keys. The arrows illustrate the existence of a \emph{FOREIGN KEY REFERENCES} statement in the \emph{DBInitScript.sql} file.\\

A key goal for the system was to enable system administrators the maximum flexibility to design the layers of security as they see fit. Inspired by the UNIX philosophy of user access, users can be given individual permission or denied permission to access any zone. Users can also be placed in groups to allow or deny groups of users to access zones.\\

The term zone is left vague, as zones can be defined to encompass entire organizations, campuses, buildings, areas within buildings, rooms or even individual lockers within a room. Zones are designed to be nested, so layers of security can be defined as tightly or as loosely as the system administrators require. Zones have an \emph{is\_inside} column, so administrators can fully express the nesting of zones.\\

A number of key design decisions that affected the rest of the system were made in the design of the database. Due to a limitation of SQLite, the values that represent True or False to define access rights, such as the \emph{access} column in \emph{Group\_Access} and \emph{User\_Access}, use the INT datatype so that they can be represented as 0 and 1 due to the fact that SQLite does not have a boolean datatype. It was decided not to use SQLite's build-in auto-incrementing primary key \emph{rowid} for the tables that are not using TEXT primary keys, as it minimises the changes needed to the source code to make it compatible with other relational databases. However it should be noted that the SQLite engine simply regards these columns as aliases for \emph{rowid}. In addition to this, because the SQlite engine still adds a primary key \emph{rowid} column to tables that have a non-INT primary key, such as \emph{Door} and \emph{User}, it was necessary to make any primary key columns using the TEXT datatype UNIQUE, which would not usually be necessary with a standard relational database.\\

The access linking tables \emph{User\_Access} and \emph{Group\_Access} can be further restricted with fields for expiring the permission, and restricting access to between two time periods. Expiration is set as a timestamp, so very fine control over the expiration time can be achieved. This is especially useful for visitor groups.

\begin{figure}[H]
\caption{Database Entity Relationship Diagram}
\centering
\includegraphics[scale=1, angle=90]{./Resources/DB-ERD-landscape.pdf}
\label{fig:DB-ERD}
\end{figure}

\newpage
\begin{figure}[H]
\caption{Database Logical Relationship Diagram}
\centering
\includegraphics[scale=1, angle=90]{./Resources/LRD.pdf}
\label{fig:DB-LRD}
\end{figure}

\section{Implementation}

This section will summarise and evaluate the process of implementing the system following the design specifications set out previously. It will also cover any obstacles that presented themselves during the implementation, design flaws uncovered, and recommendations on how to improve the system in later iterations.\\

\subsection{Android Application}
% TO WRITE ABOUT: Passing parameters with # and why it's secure (ish)

%Pivot to webapp
For the purposes of this technology demonstration a responsive mobile-first webapp, instead of a native Android application, was built that has all the functionality of a native application. This decision was made because of the restrictive timescale under which this demonstration was developed. The transition from using a webapp rather than a native application demonstrates the flexibility of the design of the API and the system architecture in general. A native Android or IOS application could be built using the existing infrastructure of the system without any significant modification.\\

Users are able to scan a QR code, which is generated by the API and displayed using the dashboard, using any existing QR code scanner on their mobile device. The QR code contains a link to the webapp with credentials being passed to the application using URI fragments. Proceeded by a hash symbol, parameters are encoded in a key/value format separated by an ampersand. The Javascript code then reads and parses these parameters and saves the information in the browsers using the web storage API. Here, values can be stored and recalled as needed, so when the webapp is opened again the users credentials are retained. The QR code below is an example, which contains the following string:\\

\url{http://192.168.0.20:81/#uid=SnFLOwdkedAhJnccBEUvWN1hdhvfiCL4FZXQbXl8RRySTx7gXqyO9AEMpXTuaeVk&secret=ntK7Rs5R1DRTEXibN9gnGjNRImiGTqWKviWjtGnUniVL83PwFyv9IBPUKbcU6OKz5XfeOCKsdiQKkFaNzrnt0460nMPsaHteK9BeUQlOvHVYuhfly4MkUtrAc38G4aEO&name=Matt Cane}\\

\begin{center}
\includegraphics[scale=0.25]{./Resources/qrUserCreds.png}
\end{center}

Once the user scans the code and opens the URL, the webapp will begin generating a new TOTP QR Code every 10 seconds until the user presses the ``Forget Identity'' button which clears the browsers localStorage, preventing more tokens from being generated. The QR code generation is handled by the library QRCode.js (Shim, 2015). This library has a very easy to implement interface with all the features required for the project, namely the ability to quickly generate QR codes of different resolutions. This library worked exceptionally, proving to be robust and accurate in it's code generation. The HMAC implementation is handled by the library jsSHA (Turek, 2021) which is an open-source, pure Javascript implementation of the SHA family of hashing algorithms. This was chosen for it's open-source nature, it's use of pure Javascript, and it's ease of implementation.\\

% Responsive
The webapp has been designed to be fully responsive and makes the best use of the screen size available to it. The QR codes are generated dynamically and are rendered in a resolution that is appropriate to the screen size. This gives the codes the best chance of being read quickly and accurately by the door scanner.\\

\subsection{Door Scanner}

The development of the door scanner followed a different process to the rest of the system, as it involved utilising hardware though software libraries that could not be replicated on a desktop development environment. Therefore, it was essential that the development and testing was done on the Raspberry Pi Zero W. This could be done by writing code using a desktop IDE, pushing the code to Git, pulling the code onto the Raspberry Pi Zero W using SSH, and then running the code to test it's functionality. This, however, slowed the development process significantly. Another option which was explored, was editing the code files directly over SSH, although this limited the choice of editors to command line only tools such as Nano and Vim. The most effective solution found was to use SSHFS which allows a directory to be mounted as a network drive using SSH, enabling the use of fully featured IDEs without having to push to and pull from a remote repository each time to test the code This greatly sped up development.\\

\subsubsection{Software}
% TO TALK ABOUT: Flags (debug, quiet), on-device logging, env.

The door scanner code was written around a core loop which can be summarised using the following pseudocode:\\

\begin{listing}[h]
\caption{Door Scanner Loop Pseudocode}
\begin{longfbox}[code]
\begin{minted}[linenos]{python}
While True:
	buffer = captureFrameFromCamera()
	if QRcode in buffer:
		code = parse(code)
		if isValid(code):
			openDoor()
		else:
			rejectCode()
\end{minted}
\end{longfbox}\\
\end{listing}

The \emph{isValid()} is the most simplified function in the pseudocode. Is encompasses calling the API with the user ID and provided by the QR code as well as the doors ID. The code is written in a highly abstracted way, and as the door scanner was the first completed component, many functions could be reused in the back-end code, improving the efficiency of the development time.\\

\newpage % ================================================================================

The Python file that runs door scanner, \emph{stream-scanner.py}, has a number of features that aided in the development and testing. The first of which is the use of command-line arguments:

\begin{itemize}
\item A debug mode flag which prints extra information to the terminal and saves more information to the local log file, as well as accepting test codes that are authorised locally on the device, negating the need for an API connection.
\item A quiet mode flag, which disables the buzzer. This is useful when debugging API connection issues, as the buzzer, by default, is set to sound on every failed connection attempt.
\item Flags to set the sensor mode which, as shown in table \ref{tab:PiCamModes}, affect the resolution of the capture and thus the capture time. This was used for testing a performance analysis.
\end{itemize}

In addition to sending logs to the API, the software also records extensive logs to \emph{/var/logs/scanner.log} on the filesystem of the Raspberry Pi Zero W. This proved very useful when debugging and testing the software and hardware as the source of crashes and bugs could be identified quickly. The software loaded the URL for the API from the \emph{id.env} file, which allowed the API URL to be quickly changed.\\

For this demonstration, the software must be run manually through an SSH connection, however, in deployment the Python file could be added as a start-up service to the operating system's init system, systemd. The operating system running on the Raspberry Pi Zero W is Raspberry Pi OS which is based on Debian, however, a lighter operating system such as Raspberry Pi OS Lite or Alpine for ARM may improve the performance of the software through reduced overheads.\\

% TESTING
Testing was performed on the door scanner software initially through the use of the \texttt{-{}-debug} flag which allowed test codes to be detected and validated offline. Before the API was in working state, this was the main method of testing. The scanner was then tested using a variety of different barcode types, as the software library used to read the captured images, PyZBar, (see section \ref{PyZBar}) can capture many different types of barcode. However, the software was written to only accept QR codes, so testing was required to ensure the validity of this function. Once the API was working, more extensive testing could be done with other types of invalid codes, such as expired codes and codes of an inappropriate length or format.\\

\subsubsection{Hardware}

The audio/visual alerts on the door scanner require a basic circuit, which can be seen in figure \ref{fig:pihardware}. The three LEDs are current regulated by their own 330$\Omega$ resistor to ensure they do not pull more current than the GPIO pins can supply, which could damage the Raspberry Pi Zero W. The buzzer, however, needs no such protection. Each of the components are fed into a common ground on pin 9. The Raspberry Pi Zero W can be powered in two different ways, through the micro-USB port on the left side of the device or by using an external DC to DC converter board connected to GPIO pins 4 and 6 are used for power and grounding respectively. The converter board converts +9v DC current supplied by a wall power supply to +5v DC current. This has the advantage of there not being any power cables exposed at the front or side of the device, as can be seen on page \pageref{fig:door}. Powering the Raspberry Pi Zero W through the GPIO pins is potentially hazardous, as it bypasses the fuse protection provided by the USB port and powers the board directly through the +5v rail, (see figure \ref{fig:piGPIO}) so a good quality converter board is required to ensure the Raspberry Pi Zero W receives the correct voltage at no higher than 1.2 amps. The converter board, which is the Eelegoo Power MB V2, was tested using a multimeter before use to ensure it's adherence to the required voltage.\\

\begin{figure}[H]
\caption{Raspberry Pi Zero W GPIO Schematic (Thornton, 2015)}
\centering
\includegraphics[scale=2]{./Resources/pi-pins.pdf}
\label{fig:piGPIO}
\end{figure}

\begin{figure}[H]
\caption{Door Scanner Wiring Diagram}
\centering
\includegraphics[scale=1]{./Resources/pi-hardware.pdf}
\label{fig:pihardware}
\end{figure}

During development, the diagram was first mocked up on an electronics breadboard as a proof-of-concept before being hand soldered together for the final demonstration unit. In a production unit the circuit could easily be integrated into a small PCB which could slot into place behind the Raspberry Pi Zero W, in a similar way to commercially available Raspberry Pi hats. For the purposes of the system proof of concept and demonstration, a scale model has been built to simulate how the door scanner might look when mounted to a door, with the LED lights fitted alongside, as can be seen below in figure \ref{fig:door}.\\

\begin{figure}[H]
\caption{Door Scanner Scale Model}
\centering
\includegraphics[scale=0.2]{./Resources/door.png}
\label{fig:door}
\end{figure}

\newpage % NEW PAGE
% Testing
The implementation of the hardware required only a small amount testing. Firstly, it was established that the LEDs and buzzer were operable through the software library gpiozero. Helper functions were then written within the software to call the library in an asynchronous manner using the multithreading Python library Threads. Integrating the LEDs and buzzer into the software was then a straightforward process.\\

\subsection{Back-End}
% TO WRITE ABOUT: Overall architecture of the backend, advantages of seperate database(grafana?), nginx reverse proxy

The overall architecture of the back-end proved to be an effective and efficient design. The decision to use an integrated database made development much more streamlined rather than having to configure and manage a stand-alone DBMS. However, given more development time, future iterations could see advantages by using a DBMS, such as the ability to host one database instance for multiple deployments of the system, and the possibility of consolidating logs from many systems using a time series database such as InfluxDB. While this would be possible using the existing system, the abstraction of the database behind the API makes this more challenging.\\

Security is also an area that could be improved in later iterations. Password protecting the web interface, utilising token authentication for sensitive parts of the API, and adding TLS support would all be worthwhile improvements. While Flask and Nginx both support easy TLS integration, a more robust solution would be to put the web interface and API behind a reverse-proxy, and incorporate TLS encryption to the reverse-proxy using a service such as LetsEncrypt's CertBot, which can be used to obtain certificates for no fee.\\ 

A requirements file was created which lists all of the Python dependencies necessary to run the system. This file is copied into the container during the build process and are all installed automatically using pip, Python's package manager. This technique proved very efficient as each time the container is built, the latest version of all the dependences were downloaded and installed. Therefore, no additional dependences, other than Docker and Docker Compose, are required to be installed on the host system in order to initialise the software.\\

The \emph{docker-compose.yml} file, which defines how Docker Compose builds and runs the system, can be found below in listing \ref{lst:compose.yml}. It shows a number of key design decisions that shaped how the project was written and would be used. Both the API and the dashboard containers have their default ports, 5000 and 80 respectively, passed from inside the container to the network. These were used as port 5000 is the default port of Flask, and port 80 is the default port of Nginx. The webapp has port 81 mapped to the network rather than it's default port of 80, to avoid conflicts with the dashboard. In a production environment, the port differences would be abstracted away behind a reverse proxy using sub-domains, however for this demonstration they are left as-is.\\

\begin{listing}[H]
\caption{docker-compose.yml File}
\label{lst:compose.yml}
\end{listing}
\begin{longfbox}[code, breakable=true]
\inputminted[linenos]{yaml}{./Resources/Code/docker-compose.yml}
\end{longfbox}\\

The only container that is not completely ephemeral is the API container, as database persistence is required. To achieve this, the directory containing the database file is mounted to an exterior directory using a volume. This allows for the database file to be backed up or edited by external software which is essential during development and deployment. Each of the containers are built using their own Dockerfiles, which are used to copy in project files and install dependences. An example of a Dockerfile used in this project can be seen in listing \ref{lst:dockerfile}. It first defines the base container as Python 3, then copies the source code and requirements list into the container and installs the requirements with pip. It is then set to run the \emph{flask-api.py} file on container start-up.\\

% Dockerfile example
\begin{listing}[H]
\caption{api.Dockerfile File}
\label{lst:dockerfile}
\end{listing}
\begin{longfbox}[code, breakable=true]
\inputminted[linenos]{dockerfile}{./Resources/Code/api.Dockerfile}
\end{longfbox}\\

\subsubsection{API}
% TO WRITE ABOUT: Image weirdness, use of requestParser, has no security (could use access tokens?), bad planning.

Implementing the API using Flask-RESTful was a good choice, as the framework provides quick and simple ways to add endpoints and parse requests. The process of implementing an endpoint is the following:

\begin{enumerate}
\item Define a resource for the API with \emph{add\_resource()}, passing the name of the class that handles the request and a path.
\item Create an argument parser using \emph{reqparse.RequestParser()} and define any arguments that should be passed with a request using \emph{add\_argument()}.
\item Define a class with methods for each of the HTTP methods that are to be accepted.
\item Parse the arguments passed to the method by using \emph{.parse\_args()} on the argument parser.
\item Process the request using an approprate function from the \emph{dbQuery} class.
\item Return the data appropriate to the request. Flask RESTful will convert any Python dictionary or string into an appropriate format for the response.
\end{enumerate}

Listing \ref{lst:apiZones} shows an example resource class that returns or adds a zone:\\

\begin{listing}[H]
\caption{apiZones API Resource Class}
\label{lst:apiZones}
\end{listing}
\begin{longfbox}[code, breakable=true]
\inputminted[linenos]{python}{./Resources/Code/apiZones.py}
\end{longfbox}\\

The API was also required to generate QR codes that users could scan during the onboarding process to receive their user credentials. The library python-qrcode (Lincoln Loop, 2020) was used for this process. This library generates a Pil image object, which is then written to a temporary file and served though the API. Python's build-in HMAC library is used to generate the tokens from the user ID and their secret.\\

Implementation was begun without a fully completed design, and the endpoints were created as needed by the system. This led to inconsistencies in naming convention and usage between different parts of the API, which is not in adherence with industry best practices. This resulted in confusion as the number of endpoints and their sophistication grew with the project. In future iterations of the system, the API should be fully planned out before any implementation begins following a consistent naming scheme, response codes and messages and HTTP method usage.\\

\subsubsection{Web Interface}
% TO WRITE ABOUT: CORS, button triggering table and JS, not password protected

The basic layout and styling was created very quickly, as the chosen CSS framework, W3.css, allows for a functional reactive site to be constructed with very little code. The front-end scripting was the most challenging aspect of the implementation of this part of the system, as the aim was made to write the JavaScript functions as abstractly as possible to reduce repeated code. For example, the \emph{addFormData} function, which can be seen in listing \ref{lst:addFormData}, takes an API endpoint, and the ID of a form, as arguments and then retrieves all the data entered in that form regardless of how many fields the form contains. It then creates a JSON object and passes it to the \emph{doPost()} function, which performs a POST request with the data. This works with any form and greatly simplifies the process for creating a working form. One issue that did arise from this is that the button that triggers the JavaScript function must be outside the form, as the HTML interprets pressing the button as triggering the form action which caused unexpected errors. However, a more suitable way to solve this issue would be to call the appropriate function in the action attribute of the form, for example \texttt{action="javascript:function()"}.\\

\newpage % ================================================================================

\begin{listing}[H]
\caption{addFormData Javascript Function}
\label{lst:addFormData}
\end{listing}
\begin{longfbox}[code, breakable=true]
\inputminted[linenos]{javascript}{./Resources/Code/addFormData.js}
\end{longfbox}\\

Another area of consideration arose due to cross-origin resource sharing (CORS). CORS is the action of requesting resources using JavaScript from a different URL, for example, when using the \emph{fetch()} function in a JavaScript script to request data from an API. Modern browsers implement cross-origin security, which blocks this from happening unless the server which is having data requested from it specifically allows it. This includes sites using the same domain but a different port. The web server uses port 80, while the API uses port 5000, therefore CORS security is enforced. This was overcome by using the flask\_cors plugin, which enables CORS requests to the API.\\

\subsubsection{Database}
% TO WRITE ABOUT: Database autocommit mode, group being a keyword

A number of issues were overcome during the implementation of the database. One of those was that while \emph{SELECT} statements worked as expected, \emph{INSERT} statements were executing with no errors but no entries were being added to the database. It was discovered that by default the Python implementation of SQLite operates in a manual commit mode, where the updates are rolled back unless a \emph{.commit()} operation is performed on the connection object. Due to the design of the \emph{dbQuery} class, this was made difficult so the decision was made to instantiate the connection with the flag \emph{isolation\_level=None}, which instantiated the connection with autocommit turned on. This is not ideal from a database design perspective as problems can arise from autocommiting bulk queries where errors may lead to data inconsistencies, so a future iteration of the \emph{dbQuery} class could be designed to allow for easier implementation of manual committing.\\

Modifications could also be made to the database structure to reduce the complexity of some queries, including creating indexes for large tables which would be queried frequently such as the \emph{Event\_Log} table. Optimisations could also be made to some of the queries executed on the database, such as the query to retrieve correctly formatted log information for the dashboard, which can be see below in listing \ref{lst:getLog}.\\

\begin{listing}[H]
\caption{Select Formatted Log Information Query}
\label{lst:getLog}
\end{listing}
\begin{longfbox}[code, breakable=true]
\inputminted[linenos]{sql}{./Resources/Code/getLogs.sql}
\end{longfbox}\\

Another minor issue was the use of `Group' as a table name. Group is a reserved keyword in SQL, so whenever the table is used it must be encased in single quotes. While this is not a large problem, using reserved keywords as names for anything in an SQL database goes against common best practices, something a refactor of the naming scheme would fix.\\

The \emph{dbQuery} class was written in a way which would self-initialise if a database file is not present in the docker container. For testing purposes a database was created and populated with test data using the \emph{dbTestEntries.sql} script and placed in the mounted volume which can be seen in the \emph{docker-compose.yml} file. Listing \ref{lst:dbinit} shows the script used to initialise the database when first created. This script is executed if there is no database file at the expected location.\\

\begin{listing}[H]
\caption{Database Initialisation Script}
\label{lst:dbinit}
\end{listing}
\begin{longfbox}[code, breakable=true]
\inputminted[linenos]{sql}{./Resources/Code/dbInitScript.sql}
\end{longfbox}\\

% Testing
The database was tested first though opening the created database file using DB Browser for SQLite (2020), which allows developers to view, modify and run SQL commands on a SQLite database. This was used to develop and test commands before their integration into the API. Once integrated into the API, the results of the SQL commands were checked using a combination of print statements into the container logs, and by manually reviewing the returned data against the expected data.\\

\newpage
\section{Conclusion}
% WILA the problem
While developing software for a security system, a number of key aspects, whose importance were not initially understood when the project began, were realised.\\

A security system must first and foremost be secure; in terms of hardware, software, and core algorithm. The basis of the algorithm at the heart of the system is derived from a well tested, mature and commonly used technology in the form of time-based one-time passwords. This strong foundation meant that the modifications made to the algorithm, to make it more appropriate for use with matrix barcodes, did not erode the utility of the software.\\

Another important aspect, which applies to any software or hardware system which which users are required to interact on a daily basis, is that it must add as little inconvenience as possible compared to alternative methods of authentication. The advantages of not having to remember passcodes for a coded door entry device, or having to keep an RFID card at hand at all times for a card based system, could be undone if the app, or webapp, is slow to load or the door scanner is slow or inaccurate at reading codes. Therefore the user experience is an important consideration when it comes to designing and implementing a secure access system.\\

% WILA the technology
The various technologies employed to implement the system each presented learning curves, some greater than others. After implementing the system to the design specification, it is clear that most of the choices of technology were well founded. The use of the Raspberry Pi Zero W with the Zero Cam proved excellent at the task of reading matrix barcodes and calling API endpoints, as it is cost effective and easy to work with given it's excellent library support and documentation. The use of Flask and SQLite in the back-end was a good choice, with the pivot from using MariaDB to SQLite making the prototype system much faster to develop with less room for error. Realistically, any of the back-end technologies could be swapped out for others, such as a fully featured DBMS or a more powerful framework such as Node.js, should the need arise. However, the choices made for this prototype fit the needs of the system adequately. The use of Docker was a good decision which was made early on and having the back-end built from the ground up, with containerisation in mind, made the development process much more organised and effective, especially when paired with extensive use of Git version control.\\

% WILA doing the project
During implementation, the decision was made to produce a webapp as opposed to the native Android app, as discussed in the design specification. This, in hindsight, should have been the design of the system from the start of the project, as developing a single platform agnostic webapp, rather than having to develop both an Android and iOS app for a production version, would significantly reduce development and operational expenses. The switch during development was therefore a positive one and this realisation proved to be a good learning experience for future projects.\\

% What would I do given enough time (dashboard UI, use better framework for web stuff, webapp to PWA)
In future iterations of the system, the main area of focus would be to improve the administrator dashboard's user interface. The dashboard design was established in order to be fast and simple to develop, however, it is missing many key features which would be required for a production ready system. The choice of framework, W3.css, was appropriate for the prototype system as it is very simple and fast to develop with, however, a more fully featured framework such as Vue.js would be a better choice in the long-term as it provides a more comprehensive set of features. In addition, the use of a JavaScript framework to enhance the drawing of tables and other UI elements would be a worthwhile addition.\\

The webapp, while functional, would be more practical should it be developed as a fully installable progressive webapp. This would greatly enhance the user experience as PWAs have access to a wider range of hardware resources, such as cameras, which would allow the PWA to be fully self-contained, with no need to use a 3rd party QR code reader to load user secrets onto the device. In addition, more security could be added to a PWA such as password or pin protection to prevent unauthorised access to the app in the event that a phone is lost or stolen, although the device's existing security measures would have to be broken for this to become an issue.\\

% Final words
Finally, after evaluating the prototype system developed from the research and design detailed in this report, it can be concluded that the core concept of using a barcode based TOTP authentication system has been proven to be an effective means of authenticating users for any number of access restricted environments. While some design improvements could be made based on issues uncovered during the development of the prototype, a system designed around the technologies set out by this report could form a viable product.

\newpage
\section{Glossary}
\input{Glossary.tex}

\newpage
\section{Bibliography}
\input{References.tex}


\newpage
\section{Appendices}
% \appendix
% \begin{appendices}
\subsection{Source Code}

\begin{listing}[H]
\caption{Back-End Source Code Directory}
\dirtree {%
.1 project-server.
.2 .env.
.2 .gitignore.
.2 docker-compose.yml.
.2 README.md.
.2 start.ps1.
.2 start.sh.
.2 api.
.3 api.Dockerfile.
.3 database.py.
.3 dbInitScript.sql.
.3 dbTestEntries.sql.
.3 flask-api.py.
.3 requirements.
.3 securitySystem.db.example.
.3 databaseVolume.
.4 securitySystem.db.        
.2 dashboard.
.3 dashboard.Dockerfile.
.4 content.
.5 dashboard.html.
.5 favicon.ico.
.5 index.html.
.5 script.js.
.5 w3.css.        
.2 webapp.
.3 webapp.Dockerfile.
.3 content.
.4 favicon.ico.
.4 generator-hmac.js.
.4 index.html.
.4 qrcode.min.js.
.4 script.js.
.4 w3.css.
}

Full source hosted at: \url{https://gitlab.uwe.ac.uk/m2-cane/project-server}

\end{listing}

\begin{listing}[H]
\caption{Door Scanner Source Code Directory}

\dirtree {%
.1 door-scanner.
.2 .gitignore.
.2 create-log.sh.
.2 example.
.2 false.png.
.2 README.md.
.2 streamscanner.py.
.2 testCodes.py.
.2 true.png.     
}

Full source hosted at: \url{https://gitlab.uwe.ac.uk/m2-cane/door-scanner}
\end{listing}

\end{document}

